unit GroupTyp;
{nicht auf meinem Mist gewachsen, also auch kein dummer Kommentar}
{*
** NOTE: Even though this is being entered into Public Domain, it may
**       in no wise be copied or reproduced in a literary work,
**       such as a Book, Video, Electronic Books, Code Sniplets,
**       etc, without the express consent of the Author, David Rigsby,
**       Who may be contacted via E-Mail at: BranhamTch@aol.com.
**       Im a nice guy, just give me a chance......
**
** Entered into the Public Domain by David A. Rigsby on December 29, 1995.
** Use this unit and Functions at your own risk. Feel free to modify and
** redistribute on the condition that any revisions keep this original
** header or in some way bears the name of the Author and those who may
** have modified and redistributed it. Always remember, Give Credit where
** Credit is due.... and you will feel SOOOOOOO Good about yourself..
** Ompa loompa dompa de do.....
*}

interface
uses SysUtils;

type
 TGroupInfo_t = record
    ItemName     : String;
    CmdLine      : String;
    WorkingDir   : String;
    IconFile     : String;
    GroupPosition: longint;
    IconIndex    : longint;
    Shortcutkey  : longint;
    MinimizeFlag : longint;
end;

Function ParseGroupItems(pszGroupInfo:string;var GroupInfo: TGroupInfo_t):BOOLEAN;
Function ExtractCmdLine(pszCmdLine: string): String;

implementation

Function ParseGroupItems(pszGroupInfo:string;var GroupInfo: TGroupInfo_t):BOOLEAN;
var
 iDelimFound,iBaseDelim,iBaseLength,iPrevDelimFound  : longint;
 pszDelim1,pszDelim2,pszDelim3,pszWorkString         : String;

BEGIN
 ParsegroupItems := FALSE;
 if Length(pszGroupInfo) > 10 then begin
  ParsegroupItems := TRUE;
  pszDelim1 := ',';
  pszDelim2 := '"';
  pszDelim3 := ' ';
  pszWorkString := pszGroupInfo;
  iBaseLength   := Length(pszWorkString);

  {Description}
  iDelimFound := Pos(pszDelim2,pszWorkString);
  pszWorkString[iDelimFound] := ' ';
  iDelimFound := Pos(pszDelim2,pszWorkString);
  pszWorkString[iDelimFound] := ' ';
  iDelimFound := Pos(pszDelim1,pszWorkString);
  pszWorkString[iDelimFound] := ' ';
  GroupInfo.ItemName := Copy(pszWorkString,2,iDelimFound-1);
  iPrevDelimFound := iDelimFound;

  {Command Line}
  iDelimFound := Pos(pszDelim2,pszWorkString);
  iPrevDelimFound := iDelimFound;
  pszWorkString[iDelimFound] := ' ';
  iDelimFound := Pos(pszDelim2,pszWorkString);
  pszWorkString[iDelimFound] := ' ';

  GroupInfo.CmdLine := Copy(pszWorkString,iPrevDelimFound+1,
                           (iDelimFound-1)-(iPrevDelimFound));
  iBaseDelim := Pos(pszDelim1,pszWorkString);

  while iBaseDelim < iDelimFound do begin
   iBaseDelim := Pos(pszDelim1,pszWorkString);
   if iBaseDelim <= iDelimFound then
    pszWorkString[iBaseDelim] := ' ';
  end;
  iDelimFound := Pos(pszDelim1,pszWorkString);
  pszWorkString[iDelimFound] := ' ';
  iPrevDelimFound := iDelimFound;

  {Working Directory}
  iDelimFound := Pos(pszDelim1,pszWorkString);
  pszWorkString[iDelimFound] := ' ';
  GroupInfo.WorkingDir := Copy(pszWorkString,iPrevDelimFound+1,
                              (iDelimFound-1)-(iPrevDelimFound));
  if Length(GroupInfo.WorkingDir) <= 2 then
    GroupInfo.WorkingDir := ExtractFilePath(ExtractCmdLine(GroupInfo.CmdLine));
  iPrevDelimFound := iDelimFound;

  {Icon File & Path}
  iDelimFound := Pos(pszDelim1,pszWorkString);
  pszWorkString[iDelimFound] := ' ';
  GroupInfo.IconFile := Copy(pszWorkString,iPrevDelimFound+1,
                            (iDelimFound-1)-(iPrevDelimFound));
  iPrevDelimFound := iDelimFound;

  {Group Position}
  iDelimFound := Pos(pszDelim1,pszWorkString);
  pszWorkString[iDelimFound] := ' ';
  iPrevDelimFound := iDelimFound;
  iDelimFound := Pos(pszDelim1,pszWorkString);
  pszWorkString[iDelimFound] := ' ';

  try
   GroupInfo.GroupPosition := StrtoInt(Copy(pszWorkString,iPrevDelimFound+1,
                              (iDelimFound-1)-(iPrevDelimFound)));
  except
   on EConvertError do
    ParseGroupItems := FALSE;
  end;
  iPrevDelimFound := iDelimFound;

  {Icon Index}
  iDelimFound := Pos(pszDelim1,pszWorkString);
  pszWorkString[iDelimFound] := '|';

  try
   GroupInfo.IconIndex := StrtoInt(Copy(pszWorkString,iPrevDelimFound+1,
                          (iDelimFound-1)-(iPrevDelimFound)));
  except
   on EConvertError do
    ParsegroupItems := FALSE;
  end;
  iPrevDelimFound := iDelimFound;
 end;
END;

Function ExtractCmdLine(pszCmdLine: string): String;
var
 iSpaceFound: longint;

BEGIN
 iSpaceFound := 0;
 iSpaceFound := Pos(' ',pszCmdLine);
 if iSpaceFound > 0 then
  ExtractCmdLine := Copy(pszCmdLine,1,iSpaceFound)
 else
  ExtractCmdLine := pszCmdLine;
END;
END.

