unit Tasks;

{Copyright: Dr.Peter Plass, HTW Zwickau
            1996
            Peter.Plass@banyan.th-zwickau.de
 Revisionen:
           PTasks1.0 :  1.Fassung vom 01.03.1996
           PTasks1.01:  13.03.1996
                        verschiedene kleine Unsauberkeiten beseitigt,
                        Beenden eines fremden Programms ber SendMessage
                        realisiert,
                        Bildschirmschoner aktivierbar,
                        stay on top nicht zuverlssig (Delphi-Bug?),
                        Ressourcenbedarf verringert,
                        Spaltenkontrolle bei pop1 korrigiert,
                        ...
           PTasks1.1 :  09.04.1996
                        die Leute meinten, stay on top funktioniert in
                        Delphi nicht zuverlssig, auerdem strt es hin
                        und wieder: weg damit! Bewegung der Maus im un-
                        terenTask-Bar Bereich holt das Programm an die
                        Oberflche, auerdem hole ich mir den Focus, um
                        die Hint-Funktion zu realisieren
                        ...
           PTasks2.0 :  29.04.1996
                        ganz ohne stay on top geht es auch nicht, damit
                        verhindere ich jetzt das automatische Anzeigen,
                        die Optionen: stay on top; sichtbare und Anzeige
                        werden in der Inidatei gespeichert;
                        der erste Hilfeansatz ist implementiert ...;
                        Dll-Killer entfernt, wahrscheinlich zu speziell(in
                        meiner Version bleibt er drinnen!)
                        ...
           PTasks2.01:  22.05.1996
                        Fehler im Hilfeaufruf beseitigt,

}
interface
uses
 SysUtils, DdeMan, Dropfile, Menus, ExtCtrls, StdCtrls, Buttons, Controls,
 Classes, Forms, WinTypes, Winprocs, Messages, Graphics, Dialogs, ToolHelp,
 ShellApi,WinCrt, IniFiles,XLabel;

type
 TTASKSF1 = class(TForm)
  Timer1       : TTimer;
  Panel1       : TPanel;
  TimeDate     : TPanel;
  Panel2       : TPanel;
  PopupMenu1   : TPopupMenu;
  Exit1        : TMenuItem;
  PopupMenu2   : TPopupMenu;
  starten1     : TMenuItem;
  Beenden1     : TMenuItem;
  Ausfhren1    : TMenuItem;
  N2           : TMenuItem;
  leer         : TMenuItem;
  PopupMenu3   : TPopupMenu;
  schliessen1  : TMenuItem;
  minimieren1  : TMenuItem;
  maximieren1  : TMenuItem;
  wiederhers1  : TMenuItem;
  iconisieren1 : TMenuItem;
  verdeckt     : TMenuItem;
  DropFile1    : TDropFile;
  StartButton  : TBitBtn;
  Progman1     : TMenuItem;
  schnell1     : TMenuItem;
  N1           : TMenuItem;
  N4           : TMenuItem;
  N5           : TMenuItem;
  N6           : TMenuItem;
  DDEClient    : TDdeClientConv;
  Label1       : TLabel;
  PopupMenu4   : TPopupMenu;
  Zeit1        : TMenuItem;
  Datum1       : TMenuItem;
  GDI1         : TMenuItem;
  User1        : TMenuItem;
  Sys1         : TMenuItem;
  N3           : TMenuItem;
  N7           : TMenuItem;
  Sysuhr1      : TMenuItem;
  N8           : TMenuItem;
  Dateimanager1: TMenuItem;
  N9           : TMenuItem;
  Systemsteuerung1: TMenuItem;
  About2       : TMenuItem;
  Bildschirmschoner1: TMenuItem;
  N10          : TMenuItem;
  stayontop1   : TMenuItem;
  Hilfe1       : TMenuItem;

  function getIcon(ind: Integer):THandle;
  function IconToBit(ffName: String;H,W:Integer) :TBitMap;
  function Datei_starten(path,name,para:String):Bool;
  function GetHide :Bool;
  function GetMe : Bool;
  procedure dohide(status: Integer);
  procedure DelButton ;
  procedure BuildButton (wNum :Integer);
  procedure FormCreate(Sender: TObject);
  procedure FormUpdate(Sender: TObject);
  procedure Timer1Timer(Sender: TObject);
  procedure SpeedButtonClick(Sender: TObject);
  procedure Exit1Click(Sender: TObject);
  procedure StartButtonClick(Sender: TObject);
  procedure Ausfhren1Click(Sender: TObject);
  procedure Beenden1Click(Sender: TObject);
  procedure schliessen1Click(Sender: TObject);
  procedure TimeDateDblClick(Sender: TObject);
  procedure verdecktClick(Sender: TObject);
  procedure DropFile1DropFile(Sender: TObject);
  procedure starten1Click(Sender: TObject);
  procedure ExecFile1Fail(ret : Integer);
  procedure Progman1Click(Sender: TObject);
  procedure ChangeDir(s : String);
  procedure SaveIni;
  procedure ReadIni;
  procedure doPopClick(Sender :TObject);
  procedure doPop2Click(Sender :TObject);
  procedure FormClose(Sender: TObject; var Action: TCloseAction);
  procedure About1Click(Sender: TObject);
  procedure Pop4Click(Sender: TObject);
  procedure Dateimanager1Click(Sender: TObject);
  procedure Systemsteuerung1Click(Sender: TObject);
  procedure PopupMenu3Popup(Sender: TObject);
  procedure Bildschirmschoner1Click(Sender: TObject);
  procedure stayontop1Click(Sender: TObject);
  procedure Hilfe1Click(Sender: TObject);

private
 Section   : String[15];
 Popnam,
 IniFile   : String[81];
 PPoint,
 MPoint    : TPoint;
 stay,
 makeShow  : Boolean;
 MyIniFile : TIniFile;
 Popind,
 showdate,
 Runs      : Integer;
 rec       : TRect;
public
end;

const
 max_Butt = 40;

var
 TASKSF1           : TTASKSF1;
 vis,err,ICOErr    : Boolean;
 groups,
 drpList,exeList   : TStringList;
 pop1              : TPopupMenu;
 BMP1,BMP2         : TBitMap;
 ICO               : array[0..255] of TBitMap;
 FIco1,FIco2       : THandle;
 bmp_name          : String[10];
 WinDir, HomDir    : String[81];

implementation
uses
 Form2,Form3,Form4,Form5,GroupTyp,Winhdl;
 {$R *.DFM}
 {$R BILD.RES}                        {Ordner}

var
But       : array [0 .. max_Butt] of TBitBtn;
tGroupInfo: TGroupInfo_T;

{verzichte konsequent auf Kurzform - lesbarer?? }

procedure TTASKSF1.DelButton;
var
 i,z      : Integer;

BEGIN
 z := pred(Panel2.ControlCount) - 1;  {auer Button auch ein Label auf Panel}
 for i := z downto 0 do begin
  if But[i].Focused then
   StartButton.SetFocus ;
  But[i].Free;
 end;                                 {die Ressourcen}
END;

procedure TTASKSF1.BuildButton (wNum :Integer);
var
 hdl      : HWnd;
 i,z,ind,
 zei,len  : Integer;
 fName    : String[81];

BEGIN
 DelButton;                           {vor Neubau liegt Zerstrung}
 if wNum > max_Butt then              {irgendwann mu Schlu sein}
  wNum := max_Butt;

 if (numWin = 0) then begin           {keine Aufgabe, dann Spielerei}
  makeShow        := True;
  Label1.Enabled  := True;
  Label1.Visible  := True;
  Label1.Left     := Panel2.Width div 6;  {aber nicht zu lange}
 end
 else begin
  makeShow := False;                  {es wird wieder ernst}
  Label1.Enabled  := False;
  Label1.Visible  := False;
 end;

 for i:= 0 to wNum-1  do begin        {ein Fenster = ein Button}
  But[i] := TBitBtn.Create(Panel2);

  with But[i] do begin                {nicht zu gro und nicht zu klein}
    case wNum of
     0 .. 3  : Width := Integer(Panel2.Width - (3 * 2)) div 3;
    else       Width := Integer(Panel2.Width - (wNum*2)) div wNum;
    end;

    fName    := WIN_NAM[i+1];         {wie heie ich?}
    if (AnsiUpperCase(fName) = WIN_NAM[i+1]) then {nur Grobuchstaben?}
     fName   := AnsiLowerCase(WIN_NAM[i+1]); {sieht nicht gut aus}

    Hint     := fName;                {da steht noch alles drin}
    if Width < 28 then                {auf den Button passen aber}
         zei := 0
    else zei := ((Width - 27) div 6); {nur zei Zeichen}

    len      := Length(fName);
    if (len > zei) then begin
     if zei > 3 then begin
      Delete(fName,zei-3,80);         {was zuviel ist, ist zuviel}
      fName := fName + '...';         {eigentlich hei ich mehr ...}
     end
     else fName := '...';
    end;

    Name     := 'A'+ IntToStr(i+1);   {wird nicht ausgewertet}
    Top      := 1;
    Height   := 29;
    Left     := 2 + (i * (Width + 2));
    Font.Name:= 'Times New Roman';
    Font.Size:= 8;
    Margin   := 1;
    Spacing  := -1;
    Style    := bsNew;
    PopupMenu:= PopupMenu3;

    Caption  := fName;
    if Width < 46 then
      Caption := '';                  {so klein, da geht nichts mehr}
    if Width < 26 then
      Caption := IntToStr(i+1)+ '.';  {jetzt habe ich kein Gesicht mehr}

    Tag      := i+1;
    OnClick  := SpeedButtonClick;
    ShowHint := True;
    parent   := Panel2;

    hdl      := GetWindowTask(WIN_HDL[i+1]);{mein Chef!}
    ind      := 0;

    for z := 0 to oldTasks do
     if (hdl = TASK_HDL[z]) then begin
      ind := z;                      {gesucht und gefunden}
      break;                         {hab ja alles ...}
     end;

    if Width > 25 then begin          {Bild holen lohnt nur, wenn gro genug}
     Glyph  := IconToBit(TASK_PATH[ind],24,24);
     if  NOT ICOErr then
      BMP2.Free;                      {Ressourcen}
    end;
   end;
 end;                                 {und der Nchste bitte}
END;

Function TTASKSF1.IconToBit(ffName: String; H, W: Integer) :TBitMap;
var
 t_Rect   : TRect;
 TI       : TIcon;

BEGIN
 ffName[ord(ffName[0])+1] := #0;      {hier wohnt mein Icon}
 TI := TIcon.Create;
 TI.Handle := ExtractIcon(HInstance, @ffName[1], 0);
 ICOErr    := False;

 if TI.Handle < 2 then begin          {war einer zu Hause?}
   Result := StartButton.Glyph;       {ausgetrickst}
   TI.Free;                           {Ressourcen}
   ICOErr := True;                    {alles weitere erspare ich mir}
   exit;
  end;
                                      {die erste Runde:}
 BMP1 := TBitmap.Create;
 with BMP1 do begin                   {a large child was born}
  Height := 32;
  Width  := 32;
  Canvas.Draw(0,0,TI);
 end;                                 {das Icon ist tot, es lebe ...}
 TI.Free;

 BMP2 := TBitmap.Create;              {die zweite Runde:}
 with BMP2 do begin
  Height := H;                        {wie gro, bestimme ich}
  Width  := W;                        {und wohin auch}
  T_Rect := Rect(1,1,W,H);
  Canvas.StretchDraw(T_Rect,BMP1);
 end;                                 {das groe Kind ist tot}
 BMP1.Free;                           {das war mein Traum}
 Result  := BMP2;
END;

procedure TTASKSF1.FormUpdate(Sender: TObject);
BEGIN
 case showdate of                     {als Service}
  0: TASKSF1.TimeDate.Caption   := TimeToStr (Time);
  1: TASKSF1.TimeDate.Caption   := DateToStr(Date);
  3: TASKSF1.TimeDate.Caption   := 'Syst: ' +
     IntToStr(GetFreeSystemResources(GFSR_SYSTEMRESOURCES)) +
     '%';
  4: TASKSF1.TimeDate.Caption   := 'Gdi : ' +
     IntToStr(GetFreeSystemResources(GFSR_GDIRESOURCES)) +
     '%';
  5: TASKSF1.TimeDate.Caption := 'User: ' +
     IntToStr(GetFreeSystemResources(GFSR_USERRESOURCES)) +
     '%';
 end;
 if showdate < 2 then
  TimeDate.Hint:= 'zum Einstellen von Zeit und Datum klicken'
 else
  TimeDate.Hint:= FormatDateTime('dddd, dd. mmmm yyyy',
                 StrToDate(DateToStr(Date)));

 Winhdl.GetTasks(Sender);             {das ist die eigentliche Aufgabe}
END;

procedure TTASKSF1.FormCreate(Sender: TObject);
var
 Buff     : array[0..81] of Char;
 i        : Integer;
                                      {aller Anfang ist schwer}
BEGIN
 GetWindowsDirectory(Buff,sizeof(Buff));
 WinDir       := StrPas(Buff);        {wo steht Windows?}
 HomDir       := ExtractFilePath(Application.ExeName); {wo stehe ich?}

 bmp_name     := 'Bild1';             {Ordner Icon}
 bmp_name[ord(bmp_name[0])+1] := #0;

 with rec do begin
  left  := 0;
  top   := Screen.Height - 1;
  right := Screen.Width;
  bottom:= Screen.Height;
 end;

 TASKSF1.Top  := Screen.Height - 35;
 TASKSF1.Left := rec.left;
 TASKSF1.Width:= rec.right;
 TimeDate.Left:= Screen.Width - 82 ;
 TimeDate.Hint:= FormatDateTime('dddd, dd. mmmm yyyy',
                 StrToDate(DateToStr(Date)));
 Panel2.Left  := StartButton.Width + 2;
 Panel2.Width := TimeDate.Left - Panel2.Left - 2 ;
 showdate     := 3;                   {wir starten mit Systemressourcen}
 oldTasks     := 0;                   {das ndert sich aber schnell}
 oldWin       := 0;
 Runs         := 0;                   {fr die 0-Tasks Spielerei}
 vis          := True;                {Standard: nur sichtbare Fenster}
 stay         := True;
 exeList := TStringList.Create;       {History: Ausfhren}
 exeList.Sorted := True;              {d.h. auch keine doppelten}
 exeList.Add('charmap.exe');          {einer wird geschmuggelt}

 drpList := TStringList.Create;       {Schellstartliste}
 groups  := TStringList.Create;       {Programmgruppen / Inhalt}

 pop1 := TPopupMenu.Create(self);     {Popup fr Programmgruppen/ Inhalt}
 MsgDlgButtonStyle := bsNew;
 ReadIni;                             {was steht geschrieben?}
 FormUpdate(Sender);                  {mal gucken}
                                      {vornehme Zurckhaltung...}
 for i := 1 to NumWin do begin        {aktiver Programme}
  ShowWindow(WIN_HDL[i],SW_SHOWMINNOACTIVE);
  SetWindowPos(WIN_HDL[i], HWND_BOTTOM,(i-1)*32, Screen.Height,
  32, 32,SWP_NoSize);                 {und Ordnung}
 end;
 SetCursorPos(25,Screen.Height - 20);
END;

procedure TTASKSF1.Timer1Timer(Sender: TObject);
var
 i : Integer;
 tt:HWnd;
BEGIN                                 {solange die Uhr schlgt ...}
 if makeShow then begin               {nur wenn Taskleiste leer}
  with Label1 do begin                {Hinweislabel, falls 0 Tasks}
   Left := Left - 1;
   if Left < -4 then begin
    inc (Runs);                       {aber nicht zu lange}
    if Runs > 4 then begin
     Runs := 0;                       {abschalten}
     Enabled  := False;
     Visible  := False;
     makeShow := False;
    end
    else Left := Panel2.Width div (Runs*10);
   end;
  end;
 end;
 if stay then                         { stay on top ?}
  if (GetHide) then dohide(1);        { ja, dann hervorholen?}
 FormUpdate(Sender);                  { das ist viel wichtiger}
END;

function TTASKSF1.GetHide :Bool;
BEGIN
 Result := True;
 rec.top := Screen.Height - 1;
 GetCursorPos(MPoint);                {im Taskbar Bereich?}
 if NOT(PtInRect(rec, MPoint))then begin
  rec.top := Screen.Height - 65;
  if NOT(PtInRect(rec, MPoint))then
   if (GetMe) then doHide(0);
   Result := False;
   exit;
 end;
 if (GetMe) then begin
  Result := False;                    {PTasks ist's selber}
  SetFocus;
 end;
END;

function TTASKSF1.GetMe : Bool;
var
 hWndPoint,temp   :HWnd;
 BEGIN
 Result := False;
 Mpoint.x := Screen.Width - 1;
 MPoint.y := Screen.Height -34;
 hWndPoint := WindowFromPoint(Mpoint);
 while (hWndPoint <> 0) do begin
  temp := hWndPoint;                  {Parant des Fensters suchen}
  hWndPoint := GetParent(hWndPoint);
 end;
 if (temp = Application.Handle)then
  Result := True;
END;

procedure TTASKSF1.dohide(status: Integer);
var
 i: Integer;
BEGIN
 if (status = 1) then begin
  TASKSF1.Top := Screen.Height-2;
  SetFocus;
  for i:=2 to 35 do
   TASKSF1.Top := Screen.Height-i ;
 end
 else
 for i:=35 downto 2 do
   TASKSF1.Top := Screen.Height-i ;
END;

procedure TTASKSF1.SpeedButtonClick(Sender: TObject);
var
 index    :Integer;

BEGIN
 index    := (Sender as TBitBtn).Tag; {der richtige Knopf ?}

 if IsIconic(WIN_HDL[index]) then     {anzeigen oder aufwecken?}
      ShowWindow(WIN_HDL[index],SW_RESTORE)
 else BringWindowToTop(WIN_HDL[index]);

 FormUpdate(Sender);                  {und notieren}
END;

procedure TTASKSF1.Exit1Click(Sender: TObject);
BEGIN
 StartButton.SetFocus;                {jedenfalls nicht das, was gelscht wird}
 SaveIni;
 if (MessageDlg('PTasks beenden?', mtConfirmation,
     [mbYes, mbNo], 0)) = mrYes then
  Close;                              {Ende gut, alles gut}
END;

procedure TTASKSF1.StartButtonClick(Sender: TObject);
BEGIN
 PopupMenu2.Popup(0, Screen.Height - 110); {Men unter Startknopf}
END;

procedure TTASKSF1.Ausfhren1Click(Sender: TObject);
var
 form2    :TFForm2;

BEGIN
 form2      := TFForm2.Create(self);
 form2.Left := 0;
 form2.Top  := Screen.Height - 35 - form2.Height;
 try
  form2.ShowModal;                    {das steht auf einem ganz}
 finally
  form2.Free;                         {anderen Blatt}
 end;
END;

procedure TTASKSF1.Beenden1Click(Sender: TObject);
var
 form3     :TFForm3;

BEGIN
 form3 := TFForm3.Create(self);
 SaveIni;
 try
  form3.ShowModal;                    {Restart oder Nase voll ?}
 finally
  form3.Free;
 end;
END;

procedure TTASKSF1.PopupMenu3Popup(Sender: TObject);
BEGIN
 Popind := TPopupMenu(Sender).PopupComponent.Tag;{fr alle Button das}
 Popnam := TPopupMenu(Sender).PopupComponent.Name;
END;                                             {selbe Men und ...}

procedure TTASKSF1.schliessen1Click(Sender: TObject);
var
 ret        : Bool;
 index,stat : Integer;
 whdl       : HWnd;

BEGIN                                 {... das hab ich nun davon}
 if Sender = iconisieren1 then stat := 5; {hier trenne ich die Aufgaben}
 if Sender = wiederhers1  then stat := 4;
 if Sender = schliessen1  then stat := 3;
 if Sender = minimieren1  then stat := 2;
 if Sender = maximieren1  then stat := 1;

 index := Popind;                     {hier trenne ich die Button wieder}
 whdl  := WIN_HDL[index];
 if (Popnam = But[index-1].Name) then
                                      {falls es schon weg ist beim Klicken}
                                      {z.B. Taskmanager ...}
 case stat of
  1: ShowWindow(whdl,SW_SHOWMAXIMIZED);
  2: ShowWindow(whdl,SW_HIDE);
  3: begin
      if (MessageDlg(WIN_NAM[index]+' beenden?', mtConfirmation,
         [mbYes, mbNo], 0) = mrYes) then begin;
       ShowWindow(whdl,SW_HIDE);
       ShowWindow(whdl,SW_MINIMIZE);
       SendMessage(whdl,WM_SYSCOMMAND,SC_CLOSE,0);
      end;
     end;
  4: ShowWindow(whdl,SW_RESTORE);
  5: ShowWindow(whdl,SW_MINIMIZE);
  end;
 FormUpdate(Sender);
END;

procedure TTASKSF1.TimeDateDblClick(Sender: TObject);
BEGIN
 if (showdate < 2) then               {Zeit(0) und Datum(1) einstellen}
  Datei_starten('',
                WinDir +'\control.exe',
                'Datum/Uhrzeit');
 FormUpdate(Sender);
END;

procedure TTASKSF1.verdecktClick(Sender: TObject);
BEGIN
 vis := NOT vis;                      {nur sichtbare oder auch}
 verdeckt.Checked := vis;             {versteckte Fenster (Tasks) zeigen}
 dec (oldTasks);                      {nderung provozieren!}
 FormUpdate(Sender);
END;

procedure TTASKSF1.DropFile1DropFile(Sender: TObject);
var
 i:Integer;

BEGIN
 if (drpList.Count + DropFile1.DropCount > 30) then
  MessageDlg('Bitte erst ausreichend Platz in der'+
              #10#13+
             'Schnellstartpalette schaffen!',
              mtWarning, [mbOk], 0)
 else begin
  for i := 0 to DropFile1.DropCount-1 do       {drag Liste aufbauen}
   drpList.Add(DropFile1.FileList.Strings[i]); {fr Schnellstartpalette}
  SaveIni;                                     {Inidatei aktualisieren}
 end;
END;

procedure TTASKSF1.starten1Click(Sender: TObject);
var
 form4     :TFForm4;

BEGIN
 if drpList.Count > 0 then begin      {Schnellstartpalette}
  form4      := TFForm4.Create(self);
  form4.Left := 0;
  form4.Top  := Screen.Height - 35 - form4.Height;
  form4.Show;
 end else
  MessageDlg('Die Schnellstartpalette ist leider leer.'+
      #10#13+
      #10#13+'Die gewnschten Programme oder Dokumente '+
      #10#13+'einfach auf die Task-Leiste Drag und Dropn.',
      mtInformation, [mbOk], 0);
END;

function TTASKSF1.Datei_starten(path,name,para:String):Bool;
var
 ret     : Integer;
 Ext,nam : String[81];
 res     : array [0..255] of Char;

BEGIN
 if (Pos(' ',name) = 0) then begin    {keine Kommandozeile}
  if path = '' then                   {kein Pfad?}
   path  := ExtractFilePath(name);
  ChangeDir(path);

  name  := AnsiUpperCase(name);
  Ext   := AnsiUpperCase(ExtractFileExt(name));

  if((Ext <> '.EXE') AND
     (Ext <> '.COM') AND
     (Ext <> '.BAT') AND
     (Ext <> '.PIF'))then
  begin                               {noch keine ausfhrbare Datei}
   Delete(path,Length(path),1);       {ohne Backslash}
   path[ord(path[0])+1] := #0;        {Verzeichnis}
   nam := ExtractFileName(name);      {Dokument}
   nam[ord(nam[0])+1] := #0;

   if (FindExecutable(@nam[1],@path[1],res) < 32) then {assoziated?}
        Ext := 'NOTEPAD.EXE'          {Standard? gnstig???}
   else Ext := AnsiUpperCase(StrPas(res));{Kommandozeile aufbauen}
   if (Pos(Ext,name) = 0) then
    name := Ext + ' ' + name;
  end else                            {Parameter ?}
   if para <> '' then
    name := name + ' ' + para;
 end else
  if path <> '' then                  {Verzeichnis angegeben?}
   ChangeDir(path);

 name[ord(name[0])+1] := #0;          {alles beisammen !}
 ret    := WinExec(@name[1], SW_SHOWNORMAL);
 Result := True;

 if ret < 32 then begin               {Fehler bei Ausfhrung?}
  ExecFile1Fail(ret);                 {Fehlermeldung absetzen}
  Result := False;                    {und: kein Erfolg!}
 end;
END;

procedure TTASKSF1.ExecFile1Fail(ret : Integer);
var
 s : String[50];

BEGIN                                 {Fehlermeldungen in Kurzform}
 case ret of
   0:     s:=' [ Speicherproblem ]';
   2:     s:=' [ Datei nicht gefunden ]';
   3:     s:=' [ Pfad nicht gefunden ]';
   5:     s:=' Attempt dynamically link ';
   6:     s:=' required separate data segments';
   8:     s:=' [ Speicher reicht nicht ]';
  10:     s:=' [ falsche Windows Version ]';
  11:     s:=' Executable file was invalid';
  12:     s:=' Appl.designed for a different OS';
  13:     s:=' Appl.designed for MS-DOS 4.0.';
  14:     s:=' Type of executable unknown.';
  15:     s:=' Attempt to load a real-mode appl.';
  16:     s:=' Attempt to load a sec.instance ';
  19:     s:=' Attempt to load a compressed executable';
  20:     s:=' [ erf. DLL fehlt oder ist fehlerhaft ]';
  21:     s:=' [ erfordert Windows 32-bit ]';
  31:     s:=' [ keine Verknpfung bekannt ]';
  else    s:=' [ unbekannter Grund ]';
 end;
 MessageDlg('Kann Datei nicht ausfhren! '+ #13#10
            + s, mtWarning, [mbOk], 0);
END;

procedure TTASKSF1.SaveIni;
var
 i         : Integer;
 fp        : TextFile;

BEGIN
 IniFile := HomDir + 'TASKS.INI';     {Inidatei schreiben}
 ChangeDir(HomDir);                   {Programmverzeichnis}
 try
  AssignFile(fp,IniFile);
  Erase(fp);
 except
  ;                                   {Exception ignorieren}
 end;                                 {hoffentlich hat nur die Inidatei gefehlt}
 MyIniFile := TIniFile.Create(IniFile);

 with MyIniFile do begin
  WriteInteger('PTASKS','Files',drpList.Count); {Anzahl Palettenfiles}
  for  i := 1 to drpList.Count do begin
   Section := 'File'+ IntToStr(i div 10)+
                      IntToStr(i mod 10);       {Filenummer}
   WriteString('File Liste',
               Section,
               drpList.Strings[i-1]); {Filepath}
  end;
  WriteBool('Options', 'Stay on top', stay);
  WriteBool('Options', 'nur sichtbare', vis);
  WriteInteger('OPTIONS','Anzeige',showdate);
  Free;
 end;
END;

procedure TTASKSF1.ReadIni;
var
 readS    : String[150];
 i,num    : LongInt;
 oldWert  : Integer;
BEGIN                                 {Inidatei lesen}
 IniFile := HomDir + 'TASKS.INI';     {Programmverzeichnis}
 ChangeDir(HomDir);
 MyIniFile := TIniFile.Create(IniFile);

 with MyIniFile do begin
  num := ReadInteger('PTASKS','Files',0);
  if num > 30 then num := 30;
  for i := 1 to num do begin
   Section := 'File'+ IntToStr(i div 10)+
                      IntToStr(i mod 10);
   readS := ReadString('File Liste',
                       Section,
                       '');
   drpList.Add(readS);
  end;
   stay := ReadBool('OPTIONS','Stay on top',True);
   stayontop1.checked := stay;
   vis := ReadBool('OPTIONS','nur sichtbare',True);
   verdeckt.checked := vis;
   oldWert := showdate;
   showdate := ReadInteger('OPTIONS','Anzeige',3);
   PopupMenu4.Items[oldWert].Checked  := False;
   PopupMenu4.Items[showdate].Checked := True;
  Free;                               {Ressourcen}
 end;
END;

procedure TTASKSF1.ChangeDir(s : String);
BEGIN
 if (s[Length(s)] = '\') then         {Backslash weg}
  Delete(s,Length(s),1);
 ChDir(s);
END;

procedure TTASKSF1.Progman1Click(Sender: TObject);
var
 i,spalte : Integer;

BEGIN                                 {Programmgruppen Popup}
 DDEClient.SetLink('Progman','Progman');
 DDEClient.OpenLink;                  {Verbindung aufbauen}
 groups.Clear;
 groups.SetText(DDEClient.RequestData('Groups'));
 DDEClient.CloseLink;
 GetCursorPos(PPoint);                {aktuelle Kursorposition}

 while (pop1.Items.Count > 0) do      {Popup leeren}
  pop1.Items.Delete(pop1.Items.Count -1);

 with pop1 do begin
  AutoPopup := False;
  spalte := 1;

  for i:= 0 to groups.Count-1 do begin {Popup aufbauen}
   Items.Add(
   NewItem(groups.Strings[i],         {caption}
           0,                         {shortcut}
           False,                     {checked}
           True,                      {enabled}
           doPopClick,                {notify action}
           i,                         {hctx}
           'B'+ IntToStr(i)));        {name, wird ausgewertet}

    if (i = spalte * 15) then begin   {zu lang, 2.Spalte}
     pop1.Items[i].Break := mbBreak;
     inc(spalte);
    end;
   end;

   FIco1:= LoadBitmap(hInstance, @bmp_name[1]); {Ordner Bild}

   for i:= 0 to groups.Count-1 do     {Ordner-Bild ins Popup montieren}
    SetMenuItemBitmaps(pop1.Handle,   {Menuhandle}
                       i,             {Position}
                       MF_BYPOSITION, {Interpretation von Position}
                       FIco1,         {Bitmap unchecked}
                       FIco1);        {Bitmap checked}

   Popup(PPoint.x, PPoint.y);         {an Kursorposition anzeigen}
   DeleteObject(FIco1);               {Bildhandle freigeben}
 end;
END;

procedure TTASKSF1.doPopClick(Sender: TObject);
var
 B           : array [0..255] of THandle;
 i           : LongInt;
 ret         : BOOLEAN;
 it          : String[10];
 grp         : String[50];
 tag,spalte  : Integer;
                                      {Gruppeninhalt Popup}
BEGIN
 it := TMenuItem(Sender).Name;        {welche Gruppe?}
 tag:= StrToInt(Copy(it,2,Length(it)-1));
 i  := -1;
 grp:= groups.Strings[tag];           {wieder freimachen}
 groups.Clear;

 DDEClient.SetLink('Progman','Progman');
 DDEClient.OpenLink;                  {Verbindung aufbauen}
 groups.SetText(DDEClient.RequestData(grp));
 groups.Delete(0);                    {erster Eintrag nur Info}
 DDEClient.CloseLink;

 while (pop1.Items.Count > 0) do      {erstmal leeren}
  pop1.Items.Delete(pop1.Items.Count -1);

 with pop1 do begin
  AutoPopup := False;
  spalte    := 1;
                                      {siehe GroupTyp}
  for i:= 0 to groups.Count-1 do begin
   ret := ParseGroupItems(groups.Strings[i],tGroupInfo);
   if ret = TRUE then begin           {Popup aufbauen}
    Items.Add(
    NewItem(tGroupInfo.ItemName,      {caption}
            0,                        {shortcut}
            False,                    {checked}
            True,                     {enabled}
            doPop2Click,              {notify action}
            i,                        {hctx}
            'C'+ IntToStr(i)));       {name, wird ausgewertet}

    B[i] := getIcon(i);               {Iconarray aufbauen}

    if (i = spalte * 15) then begin   {zu lang, 2.Spalte}
     pop1.Items[i].Break := mbBreak;
     inc(spalte);
    end;
   end;
  end;
                                      {Bitmaps ins Menu einsetzen}
  for i:= 0 to groups.Count-1 do
   SetMenuItemBitmaps(pop1.Handle,    {Menuhandle}
                     i,               {Position}
                     MF_BYPOSITION,   {Interpretation von Position}
                     B[i],            {Bitmap unchecked}
                     B[i]);           {Bitmap checked}

  Popup(PPoint.x, PPoint.y);          {an Kursorposition ausgeben}

  for i:= 0 to groups.Count-1 do
   ICO[i].Free;                       {Bildhandles freigeben}
 end;
END;

procedure TTASKSF1.doPop2Click(Sender: TObject);
var
 it       : String[10];
 tag      : Integer;

BEGIN                                 {Popupeintrag ausfhren}
 it := TMenuItem(Sender).Name;
 tag:= StrToInt(Copy(it,2,Length(it)-1));

 ParseGroupItems(groups.Strings[tag],tGroupInfo); {siehe GroupTyp}
 Datei_starten(tGroupInfo.WorkingDir,
               tGroupInfo.CmdLine,
               '');                   {Datei ausfhren}
 groups.Clear;
END;

function TTASKSF1.getIcon(ind : Integer): THandle;
var
 h,w        : Integer;
 TI         : TICON;
 szIconFile : PChar;
 T_Rect     : TRect;
 IC         : TBitMap;
 s          : String[81];

BEGIN
 ICOErr := False;
 Result := 0;                         {GetMenuCheckMarkDimensions lieferte}
 h      := 14;                        {bei mir nur einen Wert ???? }
 w      := 14;                        {Icons zu BMP fr Popupmen}

 szIconFile   := StrAlloc(Length(tGroupInfo.IconFile)+1);
 StrPCopy(szIconFile,tGroupInfo.IconFile);

 TI           := TIcon.Create;         {zunchst das Icon holen}
 TI.Handle    := ExtractIcon(hInstance,
                             szIconFile,
                             tGroupInfo.IconIndex);

 if TI.Handle < 2 then begin          {wo nichts ist, mssen wir}
  s := Application.ExeName;           {uns selbst bemhen ...}
  s[ord(s[0])+1] := #0;
  TI.Handle      := ExtractIcon(HInstance,@s[1],0);
 end;

 IC := TBitmap.Create;                {hier ist es noch riesig}
 with IC do begin
  Height := 32;
  Width  := 32;
  Canvas.Draw(0,0,TI);
 end;
 TI.Free;                             {Ressource}

 ICO[ind] := TBitmap.Create;
 with ICO[ind] do begin
  Height := h;                        {hier nur noch 14*14}
  Width  := w;
  T_Rect := Rect(1,1,w,h);
  Canvas.StretchDraw(T_Rect,IC);
 end;

 IC.Free;                             {Ressourcen freigeben}
 Result  := ICO[ind].Handle;          {Handle des Bildchens}
 StrDispose(szIconFile);
END;

procedure TTASKSF1.About1Click(Sender: TObject);
var
 form5     :TFForm5;

BEGIN
 form5 := TFForm5.Create(self);
 try
  form5.ShowModal;
 finally
  form5.Free;
 end;
END;

procedure TTASKSF1.Pop4Click(Sender: TObject);
var
 oldWert  : Integer;

BEGIN
 oldWert := showdate;

 if Sender = Zeit1   then showdate := 0;
 if Sender = Datum1  then showdate := 1;
 if Sender = Sys1    then showdate := 3;
 if Sender = GDI1    then showdate := 4;
 if Sender = User1   then showdate := 5;

 PopupMenu4.Items[oldWert].Checked  := False;
 PopupMenu4.Items[showdate].Checked := True;

 if Sender = Sysuhr1 then begin       {Doppelklick fr Datum und Zeit}
  Datei_starten('',
                WinDir +'\clock.exe',
                '');
 end;
 FormUpdate(Sender);
END;

procedure TTASKSF1.Dateimanager1Click(Sender: TObject);
BEGIN
 Datei_starten('',
               WinDir +'\winfile.exe',
               '');
END;

procedure TTASKSF1.Systemsteuerung1Click(Sender: TObject);
BEGIN
 Datei_starten('',
               WinDir +'\control.exe',
               '');
END;

procedure TTASKSF1.Bildschirmschoner1Click(Sender: TObject);
BEGIN
 SendMessage(WIN_HDL[0],WM_SYSCOMMAND,SC_SCREENSAVE,0);
END;

procedure TTASKSF1.FormClose(Sender: TObject;
          var Action: TCloseAction);
BEGIN
    pop1.Free;                        {Ressourcen freigeben}
 drpList.Free;  exeList.Free;
  groups.Free;

 DelButton ;                          {Buttonressourcen}
 Action := caFree;
END;

procedure TTASKSF1.stayontop1Click(Sender: TObject);
BEGIN
 stay := NOT stay;
 stayontop1.Checked := stay;
 FormUpdate(Sender);;
END;

procedure TTASKSF1.Hilfe1Click(Sender: TObject);
BEGIN
 Datei_starten('',
               'winhelp.exe',
               HomDir + '\ptasks.hlp');
END;

END.
